#ifndef __EFFECT_PLAYER_h__
#define __EFFECT_PLAYER_h__
// -*-c++-*-
// Copyright (C) 1995 NEC Corporation, Tokyo, Japan.

#include <InterViews/glyph.h>
#include <InterViews/window.h>
#include <Hs/HsMedia.h>
#include <stdio.h>

class HsViewer;
class HsEffect;
class Action;
class PolyGlyph;
class FieldEditor;
class FileChooser;
class StringChange;
class Button;
class Patch;

#ifndef _DATA_TYPE__
#define _DATA_TYPE__

typedef enum {
  AVFILE,
  COLOR,
  MONO,
  MPEG,
  JPEG,
  NON,
}DataType;

#endif

class EffectPlayer : public Glyph{
public:
   EffectPlayer();
   Glyph* make();
   void request(Requisition&) const;
   void draw(Canvas*, const Allocation&) const;
   void allocate(Canvas*, const Allocation&, Extension&);
   void pick(Canvas*, const Allocation&, int depth, Hit&);
   void map();
   HsViewer* view();
   void quit();
   
   void update();

   void accept1(FieldEditor*);
   void cancel1(FieldEditor*);
   void accept2(FieldEditor*);
   void cancel2(FieldEditor*);
   void accept3(FieldEditor*);
   void cancel3(FieldEditor*);

   unsigned long get_mode1();
   unsigned long get_mode2();
   
   void change_media();
   
   void choose(FileChooser*,boolean);
   void set_name(){}
   void avdump();

private:
   void select_media();
   void time();
   Glyph* make_margin(Glyph*);
   void show_message(char*);
   
   
   void idmake( long& id );
   void avlist( DataType, FILE* fp, HsMedia* m,
		char* filename, char* obj, boolean flag );
   void setid(char* name);
   char* checkid(char* oldname);

   HsMedia* type_for_media(DataType type, const char* name);

   HsViewer* viewer_;
   HsEffect* effect_;

   FieldEditor* nfield1_;
   FieldEditor* nfield2_;

   DataType type1_;
   DataType type2_;

   FieldEditor* mdiffer_;
   FieldEditor* mstart_;
   FieldEditor* mend_;
   FileChooser* fchooser_;
   Action* action_;
   Button* buttons1_[16];
   Button* buttons2_[2];
   Button* buttons3_[2];
   Glyph* body_;
   Window* window_;
   PolyGlyph* box_;
   Patch*   patch_;
   StringChange* duration1_;
   StringChange* duration2_;
   StringChange* duration3_;
   char* filename1_;
   char* filename2_;
   char* avfile_;
   char* newnamelist_[200];
   char* oldnamelist_[200];
   long  id_;
   int idcnt_;
};

#endif
