#ifndef iv_STRING_CHANGE_h
#define iv_STRING_CHANGE_h

// -*-c++-*-
// Copyright (C) 1995 NEC Corporation, Tokyo, Japan.

#include <InterViews/glyph.h>
#include <InterViews/_enter.h>

class Color;
class Font;
class String;

class StringChange : public Glyph {
public:
    StringChange(const String&, const Font*, const Color*);
    StringChange(const char*, const Font*, const Color*);
    StringChange(const char*, int len, const Font*, const Color*);
    virtual ~StringChange();

    virtual void request(Requisition&) const;
    virtual void allocate(Canvas*, const Allocation&, Extension&);
    virtual void draw(Canvas*, const Allocation&) const;
    virtual void pick(Canvas*, const Allocation&, int depth, Hit&);
    virtual void change_label(char*);
    virtual void set_label();

    String* get_text() { return(text_); };
  private:
    String* text_;
    Allocation allocation_;
    Canvas*        canvas_;
    Extension   extension_;
    const Font* font_;
    const Color* color_;
    Coord left_;
    Coord right_;
    Coord ascent_;
    Coord descent_;
    Coord width_;
    Coord* char_widths_;

    void compute_metrics();
};

#include <InterViews/_leave.h>

#endif
