#ifndef _iv_MultiMenu_h__
#define _iv_MultiMenu_h__

// -*-c++-*-
// Copyright (C) 1995 NEC Corporation, Tokyo, Japan.

#include <InterViews/glyph.h>
#include <InterViews/window.h>

class Action;
class PolyGlyph;
class Patch;
class Page;
class FieldEditor;
class FileChooser;
class StringChange;
class Button;

#ifndef _DATA_TYPE__
#define _DATA_TYPE__

typedef enum {
  AVFILE,
  COLOR,
  MONO,
  MPEG,
  JPEG,
  NON,
}DataType;

#endif

class MultiMenu : public Glyph{
public:
   MultiMenu();
   Glyph* make();
   void request(Requisition&) const;
   void draw(Canvas*, const Allocation&) const;
   void allocate(Canvas*, const Allocation&, Extension&);
   void pick(Canvas*, const Allocation&, int depth, Hit&);
   void map();        /*** Menu mapping   ***/
   void pmap();       /*** Player mapping ***/
   void quit();       /*** quit MultiPlayer ***/
   
   void message( unsigned int );
   void send_path( FileChooser*, boolean );
   Window* window();

private:
   Glyph*     body_;
   PolyGlyph* mbox_;
   Patch*    patch_;
   int cnt_;
   FileChooser* fchooser_;
   Window*  window_;
   DataType   type_;
   char* select_name_;
};

#endif
