#ifndef _iv_MultiPlayer_h___
#define _iv_MultiPlayer_h___

// -*-c++-*-
// Copyright (C) 1995 NEC Corporation, Tokyo, Japan.

#include <Hs/HsSession.h>
#include <InterViews/glyph.h>
#include <InterViews/window.h>
#include <Hs/HsMedia.h>
#include "MultiMenu.h"

class Patch;
class Button;
class Window;
class HsViewer;
class BoundedValue;

class MultiPlayer : public Glyph{
public:
   MultiPlayer(DataType, const char* name, MultiMenu* mm = nil);
   Glyph* make();
   void request(Requisition&) const;
   void draw(Canvas*, const Allocation&) const;
   void allocate(Canvas*, const Allocation&, Extension&);
   void pick(Canvas*, const Allocation&, int depth, Hit&);
   void quit();
   void map();        /*** Player map & unmap ***/
   void mmap();       /*** Menu   map & unmap ***/
   void remap();      /*** Colormap reset     ***/
   void nsmap();      /*** Colormap no set   ***/
   void window( Window* );
   Window* window();
   void start();
private:
   void execute();
   BoundedValue* bvalue_;
   Glyph*      body_;
   Patch*     patch_;
   Page*       page_;
   Window*   window_;
   HsViewer* viewer_;
   MultiMenu* mmenu_;
   DataType    type_;
   HsActionID  proc_;
   Action*  do_exec_;
   char*   filename_;
   boolean best_color_;
   HsSpeed speed_;
};

#endif
